#include "LPC214x.h"

#define ADC_CLK		1000000		/* set to 1Mhz */

#include "serial.h"
#include "target.h"

#include <syscalls.c>
#include <stdio.h>

void delay_ms(int x);
static int get_adc(int channel);
void send(const char *word);

int main(void)
{
	init_serial0(19200);

	char sz[8];

	while(1) {
		sprintf(sz, "%i\n", get_adc(3));
		send(sz);
		delay_ms(50);
	}
}	

void delay_ms(int x)
//Rough, not meant to be accurate
{
    volatile int a,b;
    for(a=0;a<x;a++){
        for(b=0;b<3000;b++);
    }
}

void send(const char *word)
{
	const char *temp;
	for(temp = word; *temp != 0; ++temp)
	{
		putchar_serial0(*temp);
	}
}

static int get_adc(int channel)
{
    int val;
    AD0CR = 0;
    AD0GDR = 0;

    AD0CR = 0x00200600 | channel;
    AD0CR |= 0x01000000;
    do
    {
        val = AD0GDR;                   // Read A/D Data Register
    }
    while ((val & 0x80000000) == 0);  //Wait for the conversion to complete
    val = ((val >> 6) & 0x03FF);  //Extract the A/D result

    return val;
}
